﻿
// Calendar Public Fields
var day = 0;
var date = 1;
var month = 1;
var year = 2000;
var arrButtonText = new Array();
var dateTextBoxReadOnly = null;
var dateTextBox = null;

// Function GetMonthName
function GetMonthName(no)
{
    if(no == 1) { return "Januar"; }
    if(no == 2) { return "Februar"; }
    if(no == 3) { return "Marts"; }
    if(no == 4) { return "April"; }
    if(no == 5) { return "Maj"; }
    if(no == 6) { return "Juni"; }
    if(no == 7) { return "Juli"; }
    if(no == 8) { return "August"; }
    if(no == 9) { return "September"; }
    if(no == 10) { return "Oktober"; }
    if(no == 11) { return "November"; }
    if(no == 12) { return "December"; }
}

// Function SetCurrentDate
function SetCurrentDate()
{
    var fullDate = new Date();
    day = fullDate.getDay();
    date = fullDate.getDate();
    month = fullDate.getMonth() + 1;
    year = fullDate.getYear();
    
    if(year < 1900)
    {
        year = year + 1900;
    }

    document.getElementById("divCalMonth").innerHTML = GetMonthName(month);
    document.getElementById("divCalYear").innerHTML = year.toString();
    
    FillButtonTextArray();
    FillButtons();
}

function SetDate(myDate)
{
    if(myDate.substring(0,1) == "0")
    {
        date = parseInt(myDate.substring(1, 2));
    }
    else
    {
        date = parseInt(myDate.substring(0, 2));
    }

    if(myDate.substring(3, 4) == "0")
    {
        month = parseInt(myDate.substring(4, 5));
    }
    else
    {
        month = parseInt(myDate.substring(3, 5));
    }

    year = parseInt(myDate.substring(6, 10));
    
    day = new Date(year, month - 1, date).getDay();

    document.getElementById("divCalMonth").innerHTML = GetMonthName(month);
    document.getElementById("divCalYear").innerHTML = year.toString();
    
    FillButtonTextArray();
    FillButtons();
}

// Function FillInNo
function FillInNo(beginAt, noDaysInMonth)
{
    for(var i = 0; i < noDaysInMonth; i++)
    {
        arrButtonText[i + beginAt] = (i + 1).toString();    
    }
}

// Function FillInEmpty
function FillInEmpty(beginAt, noDaysInMonth)
{
    for(var i = 0; i < 42 - beginAt - noDaysInMonth; i++)
    {
        arrButtonText[i + beginAt + noDaysInMonth] = "";    
    }
}

// Function FillButtonTextArray
function FillButtonTextArray()
{
    var fullDateDay = new Date(year, month - 1, 1).getDay();
    var noDaysInMonth = 32 - new Date(year, month - 1, 32).getDate();
    
    switch(fullDateDay)
    {
        case 1:
            FillInNo(0, noDaysInMonth); 
            FillInEmpty(0, noDaysInMonth);
        break;

        case 2:
            arrButtonText[0] = "";
            FillInNo(1, noDaysInMonth);
            FillInEmpty(1, noDaysInMonth);
        break;

        case 3:
            arrButtonText[0] = "";
            arrButtonText[1] = "";
            FillInNo(2, noDaysInMonth);
            FillInEmpty(2, noDaysInMonth);
        break;

        case 4:
            arrButtonText[0] = "";
            arrButtonText[1] = "";
            arrButtonText[2] = "";
            FillInNo(3, noDaysInMonth);
            FillInEmpty(3, noDaysInMonth);
        break;

        case 5:
            arrButtonText[0] = "";
            arrButtonText[1] = "";
            arrButtonText[2] = "";
            arrButtonText[3] = "";
            FillInNo(4, noDaysInMonth);
            FillInEmpty(4, noDaysInMonth);
        break;

        case 6:
            arrButtonText[0] = "";
            arrButtonText[1] = "";
            arrButtonText[2] = "";
            arrButtonText[3] = "";
            arrButtonText[4] = "";
            FillInNo(5, noDaysInMonth);
            FillInEmpty(5, noDaysInMonth);
        break;

        case 0:
            arrButtonText[0] = "";
            arrButtonText[1] = "";
            arrButtonText[2] = "";
            arrButtonText[3] = "";
            arrButtonText[4] = "";
            arrButtonText[5] = "";
            FillInNo(6, noDaysInMonth);
            FillInEmpty(6, noDaysInMonth);
        break;
    }
}

// Function FillButtons
function FillButtons()
{
    for(var i = 0; i < 42; i++)
    {
        document.getElementById("ButtonCal" + (i + 1).toString()).value = arrButtonText[i];
    }
}

// Function ShowCalendar
function ShowCalendar(dateTextBoxReadOnlyId, dateTextBoxId)
{
    var myDate = document.getElementById(dateTextBoxId).value;
    
    if(myDate == "dd-mm-åååå")
    {
        SetCurrentDate();
    }
    else
    {
        SetDate(myDate);
    }

        
    var leftTop = findPos(document.getElementById(dateTextBoxReadOnlyId));
    
    var myCalendar = document.getElementById("divCalendar");
    myCalendar.style.left = (leftTop[0] + 2).toString() + 'px';
    myCalendar.style.top = (leftTop[1] + 21).toString() + 'px';
    myCalendar.style.display = "block";

    dateTextBoxReadOnly = document.getElementById(dateTextBoxReadOnlyId);
    dateTextBox = document.getElementById(dateTextBoxId);
}

// Function HideCalendar
function HideCalendar()
{
    document.getElementById("divCalendar").style.display = "none";
}

// Function GetYear
function GetYear(diff)
{
    year = year + diff;
    document.getElementById("divCalYear").innerHTML = year.toString();

    FillButtonTextArray();
    FillButtons();
}

// Function GetMonth
function GetMonth(diff)
{
    month = month + diff;
    
    if(month == 13) { month = 1; year++; }
    if(month == 0) { month = 12; year--; }
  
    document.getElementById("divCalYear").innerHTML = year.toString();
    document.getElementById("divCalMonth").innerHTML = GetMonthName(month);

    FillButtonTextArray();
    FillButtons();
}

// Function DatePressed
function DatePressed(buttonNo)
{
    var myDate = arrButtonText[buttonNo - 1]; 

    if( myDate == "")
    {
        return;
    }

    var d0 = "";
    var m0 = "";
    
    if(myDate.length < 2){d0 = "0";}
    if(month < 10){m0 = "0";}

    dateTextBoxReadOnly.value = d0 + myDate + "-"  + m0 + (month).toString() + "-" + year.toString();
    dateTextBox.value = d0 + myDate + "-"  + m0 + (month).toString() + "-" + year.toString();
    
    if(dateTextBox.id == 'HiddenFieldDate1')
    {
        ValidatorEnable(RequiredFieldValidatorDate1, true);
        ValidatorEnable(CompareValidatorDate12, true);
    }
    if(dateTextBox.id == 'HiddenFieldDate2')
    {
        ValidatorEnable(RequiredFieldValidatorDate2, true);
        ValidatorEnable(CompareValidatorDate12, true);
    }

    if(dateTextBox.id == 'HiddenFieldDate3')
    {
        ValidatorEnable(RequiredFieldValidatorDate3, true);
        ValidatorEnable(CompareValidatorDate34, true);
    }
    
    if(dateTextBox.id == 'HiddenFieldDate4')
    {
        ValidatorEnable(RequiredFieldValidatorDate4, true);
        ValidatorEnable(CompareValidatorDate34, true);
    }

    var cal = document.getElementById("divCalendar");
    cal.style.display = "none";
}

function MouseOverButton(obj)
{
    if(obj.value == "")
    {
        return;
    }
    
    obj.style.color = "#FFFFFF";
    obj.style.backgroundColor = "#2020FF";
}

function MouseOutButton(obj)
{
    if(obj.value == "")
    {
        return;
    }

    obj.style.color = "#000000";
    obj.style.backgroundColor = "transparent";
}